# 1 "find.c"
# 1 "/usr/include/math.h"






extern int errno, signgam;

extern double atof(), frexp(), ldexp(), modf();
extern double j0(), j1(), jn(), y0(), y1(), yn();
extern double erf(), erfc();
extern double exp(), log(), log10(), pow(), sqrt();
extern double floor(), ceil(), fmod(), fabs();
extern double gamma();
extern double hypot(), cabs();
extern int matherr();
extern double sinh(), cosh(), tanh();
extern double sin(), cos(), tan(), asin(), acos(), atan(), atan2();
















# 1 "/usr/include/values.h"





























































































































# 35 "/usr/include/math.h"

















struct exception {
	int type;
	char *name;
	double arg1;
	double arg2;
	double retval;
};








# 2 "find.c"
# 1 "rtd.h"

struct color {
int r;int g;int b;};

struct vector {
double x;
double y;
double z;
double l;
double xzl;} ;

struct ray {
struct vector org;
struct vector dir;} ;

struct sphere_data 
  {
  struct vector cent;
  double rad;
  };

struct facet_data
  {
  struct vector point[3];
  };

union obj_data
  {
  struct sphere_data sphere;
  struct facet_data facet;
  };

struct object_data
  {
  double ior;
  double rfr;
  double rfl;
  double dif;
  double amb;
  char type;
  union obj_data object;
  };

struct mat 
  {
  struct vector x;  
  struct vector y;  
  struct vector z;  
  };

struct obj_link 
  {     
  struct object_data *the_object;
  struct obj_link  *next_obj, *ptr;
  };

# 3 "find.c"
# 1 "extern.h"

# 1 "constants.h"











# 2 "extern.h"

extern double ground[300][300],sam;
extern char *malloc();
extern struct obj_link *seads[40+1][40+1][40+1];
extern double  sp_x, sp_y, sp_z, sp_r;
extern double  num_pts_per_sead, half_side, sead_radius;  
extern double  x_world_start, x_world_end,         
       y_world_start, y_world_end,              
       z_world_start, z_world_end;
extern int  min_x_sead, max_x_sead, min_y_sead, max_y_sead, 
       min_z_sead, max_z_sead;
extern struct object_data *data; 
extern struct sphere_data light_source;
extern int level,nob;
extern int xground, yground;

# 4 "find.c"
# 1 "macros.h"




                          


                         


                         


                         


                         


                         


                         


                         


                         



                         


                         




                         


                         


                         








                   


                   
# 5 "find.c"

int d_bug = 0;

double  findo (m, s) 
struct mat *m;
struct sphere_data  *s;
{
                           
    struct vector   foops;
    double  t;
        foops.x=  ( (*m).x.x* s -> cent.x+ (*m).x.y* s -> cent.y+ (*m).x.z* s -> cent.z);foops.y=  ( (*m).y.x* s -> cent.x+ (*m).y.y* s -> cent.y+ (*m).y.z* s -> cent.z);foops.z=  ( (*m).z.x* s -> cent.x+ (*m).z.y* s -> cent.y+ (*m).z.z* s -> cent.z);;

                          
    t = s -> rad * s -> rad - foops.y * foops.y - foops.z * foops.z;
    if (t > 0)
	t = foops.x + sqrt (t);
    else
	t = 0;
                          

    return (t);
}

double  find (m, s)
struct mat *m;
struct sphere_data  *s;
{
    struct vector   foops;
    double  t;
        foops.x=  ( (*m).x.x* s -> cent.x+ (*m).x.y* s -> cent.y+ (*m).x.z* s -> cent.z);foops.y=  ( (*m).y.x* s -> cent.x+ (*m).y.y* s -> cent.y+ (*m).y.z* s -> cent.z);foops.z=  ( (*m).z.x* s -> cent.x+ (*m).z.y* s -> cent.y+ (*m).z.z* s -> cent.z);;
    t = s -> rad * s -> rad - foops.y * foops.y - foops.z * foops.z;
    if (t > 0)
	t = foops.x - sqrt (t);
    else
	t = 0;
    return (t);
}

double  finds (m, s)

struct mat *m;
struct sphere_data  *s;
{
    struct vector   foops;
    double  t;
        foops.x=  ( (*m).x.x* s -> cent.x+ (*m).x.y* s -> cent.y+ (*m).x.z* s -> cent.z);foops.y=  ( (*m).y.x* s -> cent.x+ (*m).y.y* s -> cent.y+ (*m).y.z* s -> cent.z);foops.z=  ( (*m).z.x* s -> cent.x+ (*m).z.y* s -> cent.y+ (*m).z.z* s -> cent.z);;
    t = s -> rad - sqrt (foops.y * foops.y + foops.z * foops.z);
    if (t > 0)
	t = t / foops.x;
    else
	t = 0;
    return (t);
}




double  shadow (p)
struct vector  *p;
{
    struct mat  trans;
    struct sphere_data   ss;
    struct vector   d;
    struct ray r;
    struct obj_link *ptr, *three_dda(), *three_next();
    struct object_data *c;
    int     i;
    double  l,
            k,
            x,
            y,
            z,
            finds ();

    l = 0.0;
    c = 0;
      d.x= light_source.cent.x- (*p).x;d.y= light_source.cent.y- (*p).y;d.z= light_source.cent.z- (*p).z;;
    d.l = 	   sqrt(	   ( (d.x*d.x+d.y*d.y+d.z*d.z)));
    d.xzl = 	   sqrt(d.x*d.x+d.z*d.z);
    mt (&(d), &trans);

        r.org.x= p->x; r.org.y=  p->y; r.org.z=  p-> z;;
        r.dir.x= d.x; r.dir.y=  d.y; r.dir.z=  d.z;;
    ptr = three_dda(&r);
    while (ptr != 0) {
      while (ptr != 0) 
        {
        if (ptr->the_object->type == 'S')
          { 
	  ss.rad = ptr->the_object->object.sphere.rad;
	    ss.cent.x= ptr->the_object->object.sphere.cent.x- (*p).x;ss.cent.y= ptr->the_object->object.sphere.cent.y- (*p).y;ss.cent.z= ptr->the_object->object.sphere.cent.z- (*p).z;;
	  if ((k = finds (&trans, &ss)) > l) 
            {
	    c = ptr->the_object;
	    l = k;
	    }  
          }   
        ptr = ptr->next_obj;
        }     
      ptr = three_next();
    }         
    if (c == 0)
	k = 200.0;
    else {
	k = 1.0 - l / ((light_source.rad) / (d.l));
	if (k < 0.0)
	    k = 0.0;
	k *= 200.0;
    }
    return (k);
}



double find_facet(ptr, r, intersect_pt, normal)
struct object_data *ptr;
struct ray *r;
struct vector *intersect_pt;
struct vector *normal;

{
  
double t, d, x5, y5, z5, divisor;
struct vector v1, v2, vec1, vec2, vec3, norm, new;

  
    vec1.x= ptr->object.facet.point[0].x; vec1.y=  ptr->object.facet.point[0].y; vec1.z=  
     ptr->object.facet.point[0].z;; 
  
    vec2.x= ptr->object.facet.point[1].x; vec2.y=  ptr->object.facet.point[1].y; vec2.z=  
     ptr->object.facet.point[1].z;; 
  
    vec3.x= ptr->object.facet.point[2].x; vec3.y=  ptr->object.facet.point[2].y; vec3.z=  
     ptr->object.facet.point[2].z;; 
  
    v1.x= vec1.x- vec2.x;v1.y= vec1.y- vec2.y;v1.z= vec1.z- vec2.z;;
    v2.x= vec2.x- vec3.x;v2.y= vec2.y- vec3.y;v2.z= vec2.z- vec3.z;;

   norm.x =  v1.y *  v2.z -  v1.z *  v2.y;                                 norm.y =  v1.z *  v2.x -  v1.x *  v2.z;                                 norm.z =  v1.x *  v2.y -  v1.y *  v2.x;
  norm.l = 	   sqrt(	   ( (norm.x*norm.x+norm.y*norm.y+norm.z*norm.z)));
    norm.x*= (1.0/norm.l); norm.y*= (1.0/norm.l); norm.z*= (1.0/norm.l); norm.l*= (1.0/norm.l);;

  divisor =  (norm.x* r->dir.x+norm.y* r->dir.y+norm.z* r->dir.z);
  if (divisor != 0)
    {
    t = ( (norm.x* vec1.x+norm.y* vec1.y+norm.z* vec1.z) -  (norm.x* r->org.x+norm.y* r->org.y+norm.z* r->org.z)) / divisor;
        new.x= r->dir.x; new.y=  r->dir.y; new.z=  r->dir.z;;
    new.l = 	   sqrt(	   ( (new.x*new.x+new.y*new.y+new.z*new.z)));
      new.x*= t; new.y*= t; new.z*= t; new.l*= t;;
    t = new.l;
      (*intersect_pt).x= r->org.x+ new.x;(*intersect_pt).y= r->org.y+ new.y;(*intersect_pt).z= r->org.z+ new.z;;
    normal->x = norm.x;
    normal->y = norm.y;
    normal->z = norm.z;
    normal->l = norm.l;
    normal->xzl = norm.xzl;

if (d_bug)
    {
    printf("vec1 x = %5.2f  y = %5.2f  z = %5.2f\n",
      vec1.x, vec1.y, vec1.z);
    printf("vec2 x = %5.2f  y = %5.2f  z = %5.2f\n",
      vec2.x, vec2.y, vec2.z);
    printf("vec3 x = %5.2f  y = %5.2f  z = %5.2f\n",
      vec3.x, vec3.y, vec3.z);
    }

    if (point_inclusion(intersect_pt, &vec1, &vec2, &vec3))
           
      {
	if (d_bug)
	   {
    	    printf("FACET INTERSECTION t= %5.2f\n", t);
      	    printf("   i_pt x = %5.2f  y = %5.2f  z = %5.2f\n",
            intersect_pt->x, intersect_pt->y, intersect_pt->z);
	   }
      return(t);
      }
    else
      return(0.0);
    }
  else
    return(0.0);
} 

int HALF_PLANE(x,y,x1,y1,x2,y2)





float  x,y,x1,y1,x2,y2;
{
  float   a,b;
  short   c;

  if (d_bug == 1 )
    printf("\n HALF_PLANE(%5.2f,%5.2f,%5.2f,%5.2f,%5.2f,%5.2f",x,y,x1,y1,x2,y2);

  a = (x - x1) * (y2 - y1);
  b = (x2 - x1) * (y - y1);
  if ( a > b ) 
    c = 1;
  else 
    if ( a < b ) 
      c = -1;  
    else 
      c = 0;

  if  (d_bug)
     printf("\nleaving half plane and result is %d",c);

  return(c); 
}



int point_inclusion(intersect_pt, vec1, vec2, vec3)
struct vector *intersect_pt, *vec1, *vec2, *vec3;
{

  double xtmp0, xtmp1, xtmp2, ytmp0, ytmp1, ytmp2, a, x, y, z, mindir, dx, dy, dz;
  int dummy;

  dummy = 0;
  dx = fabs( (((vec1->x) > (  (((vec2->x) > ( vec3->x)) ? (vec2->x): ( vec3->x)))) ? (vec1->x): (  (((vec2->x) > ( vec3->x)) ? (vec2->x): ( vec3->x)))) -
            (((vec1->x) < (  (((vec2->x) < ( vec3->x)) ? (vec2->x): ( vec3->x)))) ? (vec1->x): (  (((vec2->x) < ( vec3->x)) ? (vec2->x): ( vec3->x)))));
  dy = fabs( (((vec1->y) > (  (((vec2->y) > ( vec3->y)) ? (vec2->y): ( vec3->y)))) ? (vec1->y): (  (((vec2->y) > ( vec3->y)) ? (vec2->y): ( vec3->y)))) -
            (((vec1->y) < (  (((vec2->y) < ( vec3->y)) ? (vec2->y): ( vec3->y)))) ? (vec1->y): (  (((vec2->y) < ( vec3->y)) ? (vec2->y): ( vec3->y)))));
  dz = fabs( (((vec1->z) > (  (((vec2->z) > ( vec3->z)) ? (vec2->z): ( vec3->z)))) ? (vec1->z): (  (((vec2->z) > ( vec3->z)) ? (vec2->z): ( vec3->z)))) -
            (((vec1->z) < (  (((vec2->z) < ( vec3->z)) ? (vec2->z): ( vec3->z)))) ? (vec1->z): (  (((vec2->z) < ( vec3->z)) ? (vec2->z): ( vec3->z)))));

  mindir =  (((dx) < (  (((dy) < ( dz)) ? (dy): ( dz)))) ? (dx): (  (((dy) < ( dz)) ? (dy): ( dz))));
  if (mindir == dx)
    {
    x = intersect_pt->z; y = intersect_pt->y;
    xtmp2 = vec3->z;     xtmp1 = vec2->z;    xtmp0 = vec1->z;
    ytmp2 = vec3->y;     ytmp1 = vec2->y;    ytmp0 = vec1->y;
    }
  else
    {
    if (mindir == dy)
      {
      x = intersect_pt->x; y = intersect_pt->z;
      xtmp2 = vec3->x;     xtmp1 = vec2->x;    xtmp0 = vec1->x;
      ytmp2 = vec3->z;     ytmp1 = vec2->z;    ytmp0 = vec1->z;
      }
    else
      {
      x = intersect_pt->x; y = intersect_pt->y;
      xtmp2 = vec3->x;     xtmp1 = vec2->x;    xtmp0 = vec1->x;
      ytmp2 = vec3->y;     ytmp1 = vec2->y;    ytmp0 = vec1->y;
      }
    }

  if ( ((x -  (((xtmp2) > ( (((xtmp1) > (xtmp0)) ? (xtmp1): (xtmp0)))) ? (xtmp2): ( (((xtmp1) > (xtmp0)) ? (xtmp1): (xtmp0))))) > 0.000001) 
       || (( (((xtmp2) < ( (((xtmp1) < (xtmp0)) ? (xtmp1): (xtmp0)))) ? (xtmp2): ( (((xtmp1) < (xtmp0)) ? (xtmp1): (xtmp0)))) - x ) > 0.000001)
       || (( y -  (((ytmp2) > ( (((ytmp1) > (ytmp0)) ? (ytmp1): (ytmp0)))) ? (ytmp2): ( (((ytmp1) > (ytmp0)) ? (ytmp1): (ytmp0)))) ) > 0.000001)
       || (( (((ytmp2) < ( (((ytmp1) < (ytmp0)) ? (ytmp1): (ytmp0)))) ? (ytmp2): ( (((ytmp1) < (ytmp0)) ? (ytmp1): (ytmp0)))) - y ) > 0.000001))
    { 
    if  (d_bug)
      printf("\nleaving inside and result is %d",dummy);
    return(dummy);
    }

  if ( HALF_PLANE(x,y,xtmp2,ytmp2,xtmp1,ytmp1) !=
       HALF_PLANE(xtmp0,ytmp0,xtmp2,ytmp2,xtmp1,ytmp1) )
    { 
    if (d_bug)
      printf("\nleaving inside(1st half plane) and result is %d",dummy);
    return(dummy);
    }

  if ( HALF_PLANE(x,y,xtmp1,ytmp1,xtmp0,ytmp0) !=
       HALF_PLANE(xtmp2,ytmp2,xtmp1,ytmp1,xtmp0,ytmp0) )
    { 
    if (d_bug)
      printf("\nleaving inside(2nd half plane) and result is %d",dummy);
    return(dummy);
    }

  if ( HALF_PLANE(x,y,xtmp0,ytmp0,xtmp2,ytmp2) == HALF_PLANE(xtmp1,ytmp1,xtmp0,
             ytmp0,xtmp2,ytmp2))
    dummy = 1;
  else 
    dummy = 0;   

  if  (d_bug)
    printf("\nleaving inside at end and result is %d",dummy);

  return(dummy); 
}

